/**
 * 
 */
package com.javacodegeeks.JLayer;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.text.DateFormat;
import java.text.NumberFormat;

import javax.swing.Box;
import javax.swing.JComponent;
import javax.swing.JFormattedTextField;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JLayer;
import javax.swing.JPanel;
import javax.swing.SwingConstants;
import javax.swing.plaf.LayerUI;

/**
 * This example demonstrates the usage of JLayer and LayerUI class
 * to decorate the text field and datefield
 * @author bhagvan kommadi
 *
 */
public class JLayerValidator {

	/**
	 * Creating a validator UI
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub

		javax.swing.SwingUtilities.invokeLater(new Runnable(){
				
				public void run()
				{
					createValidatorUI();
				}
				
		}
				);
			
	}
	/*
	 * This method creates a JFrame and validator pane box
	 * is added to the frame
	 */
	public static void createValidatorUI()
	{
		JFrame frame = new JFrame("ValidatorUI");
		
		JComponent component = createValidatorPane();
		
		frame.add(component);
		
		frame.pack();
		
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		frame.setVisible(true);
		
	}
	
	/*
	 * This method creates the Vertical Box
	 * Textfield and Date field panels are added
	 */
	private static JComponent createValidatorPane()
	{
		
	   Dimension labelDimension = new Dimension(100,30);
	   
	   Box box = Box.createVerticalBox();
	   
	   LayerUI<JFormattedTextField> validationLayer =  new ValidationLayer();
	   
	   JLabel integerJLabel = new JLabel("Integer");
	   integerJLabel.setHorizontalAlignment(SwingConstants.RIGHT);
	   integerJLabel.setPreferredSize(labelDimension);
	   
	   NumberFormat integerFormat = NumberFormat.getInstance();
	   JFormattedTextField integerTextField = new JFormattedTextField(integerFormat);
	   integerTextField.setColumns(10);
	   integerTextField.setFocusLostBehavior(JFormattedTextField.PERSIST);
	   integerTextField.setValue(40);
	   
	   JPanel integerPanel = new JPanel();
	   integerPanel.add(integerTextField);
	   integerPanel.add(new JLayer<JFormattedTextField>(integerTextField,validationLayer));
	   
	   JLabel dateJLabel = new JLabel("Date");
	   dateJLabel.setHorizontalAlignment(SwingConstants.RIGHT);
	   dateJLabel.setPreferredSize(labelDimension);
	   
	   DateFormat dateFormat = DateFormat.getDateInstance();
	   JFormattedTextField dateTextField = new JFormattedTextField(dateFormat);
	   dateTextField.setColumns(16);
	   dateTextField.setFocusLostBehavior(JFormattedTextField.PERSIST);
	   dateTextField.setValue(new java.util.Date());
	   
	   JPanel dateJPanel = new JPanel();
	   dateJPanel.add(dateTextField);
	   dateJPanel.add(new JLayer<JFormattedTextField>(dateTextField,validationLayer));
	   
	   box.add(Box.createGlue());
	   box.add(integerPanel);
	   box.add(Box.createGlue());
	   box.add(dateJPanel);
	   
	   
	   
	   return box;
	   
	}
	
	
		
	}

