/**
 * 
 */
package com.javacodegeeks.JLayer;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;

import javax.swing.JComponent;
import javax.swing.JFormattedTextField;
import javax.swing.JLayer;
import javax.swing.plaf.LayerUI;

/**
 * This class is used for validation of
 *  fields. JLayer is instantiated using this
 *  instance as parameter
 * @author Bhagvan Kommadi
 *
 */
class ValidationLayer extends LayerUI<JFormattedTextField>
{
	@Override
	
	public void paint (Graphics graphics, JComponent component)
	{
		super.paint(graphics,component);
		
		JLayer jLayer = (JLayer)  component;
		
		JFormattedTextField formattedTextField = (JFormattedTextField) jLayer.getView();
		
		if(!formattedTextField.isEditValid())
		{
			
			Graphics2D graphics2D = (Graphics2D) graphics.create();
			
			graphics2D.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);

		    int width = component.getWidth();
		    
		    int height = component.getHeight();
		    
		    int spacing = 10;
		    
		    int padding = 5;
		    
		    int x = width - padding - spacing;
		    
		    int y = (height - spacing)/2;
		    
		    graphics2D.setPaint(Color.red);
		    graphics2D.fillRect(x, y, spacing+1, spacing+1);
		    graphics2D.setPaint(Color.white);
		    graphics2D.drawLine(x,y, x+spacing, y+spacing);
		    graphics2D.drawLine(x,y+spacing,x+spacing, y);
		    
		    graphics2D.dispose();
		    
		    
		    
		}
		
		
		
	}
}